#ifndef GLWIDGET_H
#define GLWIDGET_H

class QOpenGLShaderProgram;
class QOpenGLBuffer;
class QTimerEvent;

#include <QMatrix4x4>
#include <QOpenGLWidget>
#include <QOpenGLFunctions>

class GLWidget : public QOpenGLWidget, private QOpenGLFunctions {
public:
    explicit GLWidget(QWidget *parent = 0);
    ~GLWidget();

private:
    QOpenGLShaderProgram * m_program;
    QOpenGLBuffer * m_vertexVBO;
    QOpenGLBuffer * m_colorVBO;
    QMatrix4x4 m_matrix;
    GLuint m_posAttr;
    GLuint m_colAttr;
    GLuint m_matrixUniform;
    bool m_isRotating;
    double m_rotation;

    void initializeGL();
    void resizeGL(int w, int h);
    void paintGL();
    void timerEvent( QTimerEvent * event);
    void mousePressEvent( QMouseEvent * event );
};

#endif // GLWIDGET_H
